/* alle Rechte by achim seeger unter GPL
   myroboter@web.de, wnsche viel Spass damit */

#define F_CPU 16000000				// CPU clock in Hz
#include <stdint.h>
#include <stdbool.h>
#include <avr/pgmspace.h>
#include "HT16K33.h"
#include "i2cmaster.h"
#include "util/delay.h"
		
////////////////////////  Init 1	
void HT16K33_Init1(void)					// HT16K33 initieiren
  {  
	HT16K33_SetOscillator1(true);			// schaltet Oszillator ein 
	HT16K33_Blinken1(HT16K33_BLINK_OFF);	// SETZ 0-AUS ODER 1-EIN
	HT16K33_SetBrightness1(3);				// setzt Helligkeit max 15 (0..15)
  }
void HT16K33_SetOscillator1(bool osc_on)	// schaltet Oszi ein
  {
	i2c_start(HT16K33_modul1_addr<<1);
	if (osc_on)
	i2c_write(HT16K33_CMD_OSCILLATOR | 1);	// oscillator ein
	else
	i2c_write(HT16K33_CMD_OSCILLATOR);		// oscillator aus
	i2c_stop();								// Bus stop
  }
void HT16K33_Blinken1(uint8_t b)			// schaltet Blinken
  {
	i2c_start(HT16K33_modul1_addr<<1);
	if (b > 3) b = 0;						// Sicherheitsabfrage
	i2c_write(HT16K33_CMD_BLINK | HT16K33_BLINK_DISPLAYON | (b << 1));
	i2c_stop();								// Bus stop
  }
void HT16K33_SetBrightness1(uint8_t b)		// schaltet Helligkeit
  {
	if (b > 15) b = 15;						// Sicherheitsabfrage
	i2c_start(HT16K33_modul1_addr<<1);		// Bus start, Angabe Adresse
	i2c_write(HT16K33_CMD_BRIGHTNESS | b);	// schreibt Wert
	i2c_stop();								// Bus stop
  }
////////////////////////  Init 2
void HT16K33_Init2(void)					// HT16K33 initieiren
  {
	HT16K33_SetOscillator2(true);			// schaltet Oszillator ein
	HT16K33_Blinken2(HT16K33_BLINK_OFF);	// SETZ 0-AUS ODER 1-EIN
	HT16K33_SetBrightness2(5);				// setzt Helligkeit max 15 (0..15)
  }
void HT16K33_SetOscillator2(bool osc_on)	// schaltet Oszi ein
  {
	i2c_start(HT16K33_modul2_addr<<1);
	if (osc_on)
	i2c_write(HT16K33_CMD_OSCILLATOR | 1);	// oscillator ein
	else
	i2c_write(HT16K33_CMD_OSCILLATOR);		// oscillator aus
	i2c_stop();								// Bus stop
  }
void HT16K33_Blinken2(uint8_t b)			// schaltet Blinken
  {
	i2c_start(HT16K33_modul2_addr<<1);
	if (b > 3) b = 0;						// Sicherheitsabfrage
	i2c_write(HT16K33_CMD_BLINK | HT16K33_BLINK_DISPLAYON | (b << 1));
	i2c_stop();								// Bus stop
  }
void HT16K33_SetBrightness2(uint8_t b)		// schaltet Helligkeit
  {
	if (b > 15) b = 15;						// Sicherheitsabfrage
	i2c_start(HT16K33_modul2_addr<<1);		// Bus start, Angabe Adresse
	i2c_write(HT16K33_CMD_BRIGHTNESS | b);	// schreibt Wert
	i2c_stop();								// Bus stop
  }
////////////////////////  Init 3
void HT16K33_Init3(void)					// HT16K33 initieiren
  {
	HT16K33_SetOscillator3(true);			// schaltet Oszillator ein
	HT16K33_Blinken3(HT16K33_BLINK_OFF);	// SETZ 0-AUS ODER 1-EIN
	HT16K33_SetBrightness3(10);				// setzt Helligkeit max 15 (0..15)
  }
void HT16K33_SetOscillator3(bool osc_on)	// schaltet Oszi ein
  {
	i2c_start(HT16K33_modul3_addr<<1);
	if (osc_on)
	i2c_write(HT16K33_CMD_OSCILLATOR | 1);	// oscillator ein
	else
	i2c_write(HT16K33_CMD_OSCILLATOR);		// oscillator aus
	i2c_stop();								// Bus stop
  }
void HT16K33_Blinken3(uint8_t b)			// schaltet Blinken
  {
	i2c_start(HT16K33_modul3_addr<<1);
	if (b > 3) b = 0;						// Sicherheitsabfrage
	i2c_write(HT16K33_CMD_BLINK | HT16K33_BLINK_DISPLAYON | (b << 1));
	i2c_stop();								// Bus stop
  }
void HT16K33_SetBrightness3(uint8_t b)		// schaltet Helligkeit
  {
	if (b > 15) b = 15;						// Sicherheitsabfrage
	i2c_start(HT16K33_modul3_addr<<1);		// Bus start, Angabe Adresse
	i2c_write(HT16K33_CMD_BRIGHTNESS | b);	// schreibt Wert
	i2c_stop();								// Bus stop
  }
  ///////////////////////////////////////
void HT16K33_WriteDisplay1(uint8_t start)	// fllt komplette Matrix
  {
    for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {  
		 i2c_start(HT16K33_modul1_addr<<1); // schreibt modul 1
		 i2c_write(i);						// angabe Zeile
		 i2c_write(0xaa);					// angabe LED-alle ein
		 i2c_stop();						// Bus stop
	  }
  }
void HT16K33_WriteDisplay2(uint8_t start)	// fllt komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		i2c_start(HT16K33_modul2_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0xbb);					// angabe LED-alle ein
		i2c_stop();							// Bus stop
	  }
  }
void HT16K33_WriteDisplay3(uint8_t start)	// fllt komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		i2c_start(HT16K33_modul3_addr<<1);// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0xcc);					// angabe LED-alle ein
		i2c_stop();							// Bus stop
	  }
  }  
/////////////////////////////////////////////////
void HT16K33_ClearDisplay1(uint8_t start)	// lscht komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.	
      {
		i2c_start(HT16K33_modul1_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0x00);					// angabe LED-alle aus
		i2c_stop();							// Bus stop
	  }
  }
  
void HT16K33_ClearDisplay2(uint8_t start)	// lscht komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		i2c_start(HT16K33_modul2_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0x00);					// angabe LED-alle aus
		i2c_stop();							// Bus stop
	  }
  }
void HT16K33_ClearDisplay3(uint8_t start)	// lscht komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		i2c_start(HT16K33_modul3_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0x00);					// angabe LED-alle aus
		i2c_stop();							// Bus stop
	  }
  }
  ////////////////////////////////////////////////////////// 
void HT16K33_FillDisplay1(uint8_t start)	// fllt komplette Matrix
  {
    for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		 i2c_start(HT16K33_modul1_addr<<1); // schreibt modul 1
		 i2c_write(i);						// angabe Zeile
		 i2c_write(0xff);					// angabe LED-alle ein
		 i2c_stop();						// Bus stop
	  }
  }
void HT16K33_FillDisplay2(uint8_t start)	// fllt komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		i2c_start(HT16K33_modul2_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0xff);					// angabe LED-alle ein
		i2c_stop();							// Bus stop
	  }
  }
void HT16K33_FillDisplay3(uint8_t start)	// fllt komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		i2c_start(HT16K33_modul3_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0xff);					// angabe LED-alle ein
		i2c_stop();							// Bus stop
	  }
  }